clang 8.0.0

Public Member Functions | List of all members
clang::ento::AnalysisASTConsumer Class Referenceabstract

`#include "clang/StaticAnalyzer/Frontend/AnalysisConsumer.h"`

Inheritance diagram for clang::ento::AnalysisASTConsumer:
[legend]
Collaboration diagram for clang::ento::AnalysisASTConsumer:
[legend]

## Public Member Functions
virtual void | AddDiagnosticConsumer (PathDiagnosticConsumer *Consumer)=0
virtual void | AddCheckerRegistrationFn (std::function< void(CheckerRegistry &)> Fn)=0
| This method allows registering statically linked custom checkers that are not a part of the Clang tree. More...
Public Member Functions inherited from clang::ASTConsumer
| ASTConsumer ()
virtual | ~ASTConsumer ()
virtual void | Initialize (ASTContext &Context)
| Initialize - This is called to initialize the consumer, providing the ASTContext. More...
virtual bool | HandleTopLevelDecl (DeclGroupRef D)
| HandleTopLevelDecl - Handle the specified top-level declaration. More...
virtual void | HandleInlineFunctionDefinition (FunctionDecl *D)
| This callback is invoked each time an inline (method or friend) function definition in a class is completed. More...
virtual void | HandleInterestingDecl (DeclGroupRef D)
| HandleInterestingDecl - Handle the specified interesting declaration. More...
virtual void | HandleTranslationUnit (ASTContext &Ctx)
| HandleTranslationUnit - This method is called when the ASTs for entire translation unit have been parsed. More...
virtual void | HandleTagDeclDefinition (TagDecl *D)
| HandleTagDeclDefinition - This callback is invoked each time a TagDecl (e.g. More...
virtual void | HandleTagDeclRequiredDefinition (const TagDecl *D)
| This callback is invoked the first time each TagDecl is required to be complete. More...
virtual void | HandleCXXImplicitFunctionInstantiation (FunctionDecl *D)
| Invoked when a function is implicitly instantiated. More...
virtual void | HandleTopLevelDeclInObjCContainer (DeclGroupRef D)
| Handle the specified top-level declaration that occurred inside and ObjC container. More...
virtual void | HandleImplicitImportDecl (ImportDecl *D)
| Handle an ImportDecl that was implicitly created due to an inclusion directive. More...
virtual void | CompleteTentativeDefinition (VarDecl *D)
| CompleteTentativeDefinition - Callback invoked at the end of a translation unit to notify the consumer that the given tentative definition should be completed. More...
virtual void | AssignInheritanceModel (CXXRecordDecl *RD)
| Callback invoked when an MSInheritanceAttr has been attached to a CXXRecordDecl. More...
virtual void | HandleCXXStaticMemberVarInstantiation (VarDecl *D)
| HandleCXXStaticMemberVarInstantiation - Tell the consumer that this. More...
virtual void | HandleVTable (CXXRecordDecl *RD)
| Callback involved at the end of a translation unit to notify the consumer that a vtable for the given C++ class is required. More...
virtual ASTMutationListener * | GetASTMutationListener ()
| If the consumer is interested in entities getting modified after their initial creation, it should return a pointer to an ASTMutationListener here. More...
virtual ASTDeserializationListener * | GetASTDeserializationListener ()
| If the consumer is interested in entities being deserialized from AST files, it should return a pointer to a ASTDeserializationListener here. More...
virtual void | PrintStats ()
| PrintStats - If desired, print any statistics. More...
virtual bool | shouldSkipFunctionBody (Decl *D)
| This callback is called for each function if the Parser was initialized with `SkipFunctionBodies` set to `true`. More...

## Detailed Description

Definition at line 35 of file AnalysisConsumer.h.

## Member Function Documentation

## ◆ AddCheckerRegistrationFn()

virtual void clang::ento::AnalysisASTConsumer::AddCheckerRegistrationFn | ( | std::function< void(CheckerRegistry &)> | Fn | ) |
| pure virtual

This method allows registering statically linked custom checkers that are not a part of the Clang tree.

It employs the same mechanism that is used by plugins.

Example:

Consumer->AddCheckerRegistrationFn([] (CheckerRegistry& Registry) { Registry.addChecker<MyCustomChecker>("example.MyCustomChecker", "Description"); });

## ◆ AddDiagnosticConsumer()

virtual void clang::ento::AnalysisASTConsumer::AddDiagnosticConsumer | ( | PathDiagnosticConsumer * | Consumer | ) |
| pure virtual

The documentation for this class was generated from the following file:

- include/clang/StaticAnalyzer/Frontend/AnalysisConsumer.h